from dataclasses import dataclass
from typing import Final
import os


@dataclass(frozen=True)
class Constants:

    SP_API_BASE_URL: Final[str] = os.environ.get('SP_API_BASE_URL') or 'https://api.simplifiedprivacy.is/api/v1'
    PING_URL: Final[str] = os.environ.get('PING_URL') or 'https://api.simplifiedprivacy.is/api/v1/health'

    HV_CLIENT_PATH: Final[str] = os.environ.get('HV_CLIENT_PATH')
    HV_CLIENT_VERSION_NUMBER: Final[str] = os.environ.get('HV_CLIENT_VERSION_NUMBER')

    HOME: Final[str] = os.path.expanduser('~')

    SYSTEM_CONFIG_PATH: Final[str] = '/etc'

    CONFIG_HOME: Final[str] = os.environ.get('XDG_CONFIG_HOME') or os.path.join(HOME, '.config')
    DATA_HOME: Final[str] = os.environ.get('XDG_DATA_HOME') or os.path.join(HOME, '.local/share')
    STATE_HOME: Final[str] = os.environ.get('XDG_STATE_HOME') or os.path.join(HOME, '.local/state')

    HV_SYSTEM_CONFIG_PATH: Final[str] = f'{SYSTEM_CONFIG_PATH}/hydra-veil'

    HV_CONFIG_HOME: Final[str] = f'{CONFIG_HOME}/hydra-veil'
    HV_DATA_HOME: Final[str] = f'{DATA_HOME}/hydra-veil'
    HV_STATE_HOME: Final[str] = f'{STATE_HOME}/hydra-veil'

    HV_SYSTEM_PROFILE_CONFIG_PATH: Final[str] = f'{HV_SYSTEM_CONFIG_PATH}/profiles'

    HV_PROFILE_CONFIG_HOME: Final[str] = f'{HV_CONFIG_HOME}/profiles'
    HV_PROFILE_DATA_HOME: Final[str] = f'{HV_DATA_HOME}/profiles'

    HV_APPLICATION_DATA_HOME: Final[str] = f'{HV_DATA_HOME}/applications'
    HV_RUNTIME_DATA_HOME: Final[str] = f'{HV_DATA_HOME}/runtime'

    HV_SESSION_STATE_HOME: Final[str] = f'{HV_STATE_HOME}/sessions'

    HV_STORAGE_DATABASE_PATH: Final[str] = f'{HV_DATA_HOME}/storage.db'
