class CommandNotFoundError(OSError):

    def __init__(self, subject):

        self.subject = subject
        super().__init__(f"Command '{subject}' could not be found.")


class UnknownClientPathError(Exception):
    pass


class UnknownClientVersionError(Exception):
    pass


class UnknownConnectionTypeError(Exception):
    pass


class UnknownTimeZoneError(Exception):
    pass


class ConnectionTerminationError(Exception):
    pass


class ProfileDeletionError(Exception):
    pass


class ProfileModificationError(Exception):
    pass


class ProfileStateConflictError(Exception):
    pass


class ProfileActivationError(Exception):
    pass


class ProfileDeactivationError(Exception):
    pass


class UnsupportedApplicationVersionError(Exception):
    pass


class ApplicationAlreadyInstalledError(Exception):
    pass


class MissingLocationError(Exception):
    pass


class MissingSubscriptionError(Exception):
    pass


class InvalidSubscriptionError(Exception):
    pass


class InvoiceNotFoundError(Exception):
    pass


class InvoiceExpiredError(Exception):
    pass


class InvoicePaymentFailedError(Exception):
    pass


class ConnectionUnprotectedError(Exception):
    pass


class FileIntegrityError(Exception):
    pass
